const request = require('request');
var bodyObj;

var getAccessToken = function () {

return new Promise(function(resolve, reject) {

  var url = 'https://login.microsoftonline.com/d2bc5682-b6dd-4cd3-a16d-8a1d0f180073/oauth2/token'; // replace common with tenant id  

  var clientId = "your client id here" // Applicaton ID of app registered via Azure Active Directory 
  var clientSecret = "your client secret here" // service principal secret

  var headers = {
    'Content-Type' : 'application/x-www-form-urlencoded'
  };

  var formData = {
    grant_type:'client_credentials', 
    client_id: clientId,
    client_secret: clientSecret,
    resource:'https://analysis.windows.net/powerbi/api'

  };
 

  request.post({
    url:url,
    form:formData,
    headers:headers

  }, function(err, result, body) {

    if(err) return reject(err);
    //console.log(body);
    bodyObj = JSON.parse(body);
    //resolve(bodyObj.access_token);
  });

  //return bodyObj.access_token;
});
}

// -------------------------------------------

var getEmbedToken = function(accessToken, groupId, reportId) {

return new Promise(function(resolve, reject) {

  var url = 'https://api.powerbi.com/v1.0/myorg/groups/' + groupId + '/reports/' + reportId + '/GenerateToken';

  var headers = {
    'Content-Type' : 'application/x-www-form-urlencoded',
    'Authorization' : 'Bearer ' + accessToken
  };

  var formData = {
    "accessLevel": "View"
  };

  request.post({
    url:url,
    form:formData,
    headers:headers

  }, function(err, result, body) {
    if(err) return reject(err);
    //console.log(body)
    bodyObj = JSON.parse(body);
    //resolve(bodyObj.token);
  })
})
}
var result = getAccessToken();
while(bodyObj === undefined) {
  require('deasync').runLoopOnce();
};
var accessToken = bodyObj.access_token;

bodyObj = undefined;
result = getEmbedToken(accessToken, "58652097-80ef-4a2e-8233-1315c5863264", "cbf0c6c9-a59d-412e-b955-4c531f958f56");
while(bodyObj === undefined) {
  require('deasync').runLoopOnce();
};
var embedToken = bodyObj.token;
console.log (embedToken);
